/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved
*
* Copyright (c) 1989-2008 ARC International;
* All Rights Reserved
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: disk.c$
* $Version : 3.4.1.0$
* $Date    : Sep-15-2009$
*
* Comments:
*
* @brief  RAM Disk has been emulated via this Mass Storage Demo
*****************************************************************************/
 
/******************************************************************************
 * Includes
 *****************************************************************************/
#include "disk.h"
#include <P5Q_spi.h>


/*****************************************************************************
 * Constant and Macro's - None
 *****************************************************************************/
 
/*****************************************************************************
 * Global Functions Prototypes
 *****************************************************************************/

/****************************************************************************
 * Global Variables
 ****************************************************************************/ 
 /* Add all the variables needed for disk.c to this structure */



/*****************************************************************************
 * Local Types - None
 *****************************************************************************/
 
/*****************************************************************************
 * Local Functions Prototypes
 *****************************************************************************/


/*****************************************************************************
 * Local Variables 
 *****************************************************************************/




/*****************************************************************************
 * Local Functions
 *****************************************************************************/

int FILE_open_data(void);
int FILE_put_data(uint_32 size, uint_8 *data);
int FILE_get_data(int_8 *data);
int Intelhex_function(void);


#define	FILE_BUFFER_SIZE	(64*50)

uint_8 workfile[FILE_BUFFER_SIZE];

#define E_OK		0

uint_32	input_point;
uint_32	output_point;
uint_32	file_size;
int hex_byte_count;
int	hex_mode;
int_8 hex_data[64];
int_8 hex_code[64];

uint32 hi_addr;
uint32 lo_addr;


#define INTELHEX_NONE		0
#define INTELHEX_GET		1

PCM_SPI_MAMORY_IO  pcm_data_mem;
extern  FILE_PTR pcm_dev_handle1;


/******************************************************************************
 * 
 *    @name       Disk_App
 *    
 *    @brief      
 *                  
 *    @param      None
 * 
 *    @return     None
 *    
 *****************************************************************************/
int FILE_open_data(void)
{
	input_point = 0;
	output_point = 0;

	file_size = 0;

	hex_mode = INTELHEX_NONE;

	hex_byte_count = 0;

	hi_addr = 0;
	lo_addr = 0;

    return E_OK;
}



/******************************************************************************
 * 
 *    @name       Disk_App
 *    
 *    @brief      
 *                  
 *    @param      None
 * 
 *    @return     None
 *    
 *****************************************************************************/
int FILE_put_data(uint_32 size, uint_8 *data)
{
	uint_32 i;

	for(i=0; i<size; i++){
		workfile[input_point+i] = data[i];
	}

	file_size =  file_size + size;

	input_point = input_point + size;

	if (input_point>=FILE_BUFFER_SIZE){
		input_point = 0;
	}

    /* User Code */ 
    return E_OK;
}



/******************************************************************************
 * 
 *    @name       Disk_App
 *    
 *    @brief      
 *                  
 *    @param      None
 * 
 *    @return     None
 *    
 *****************************************************************************/
int FILE_get_data(int_8 *data)
{
	if (file_size == 0){
		*data = 00;
	    /* User Code */ 
	    return -1;
	}

	*data = workfile[output_point];
	file_size =  file_size - 1;

	output_point++;
	if (output_point>=FILE_BUFFER_SIZE){
		output_point = 0;
	}

    /* User Code */ 
    return file_size;
}


uint_8 Hex_to_char_function(int_8 data1, int_8 data2);

uint_8 Hex_to_char_function(int_8 data1, int_8 data2)
{
	uint_8 H_dataH;
	uint_8 H_dataL;

	H_dataH = 0;
	H_dataL = 0;

	if ((data1>='0')&&(data1<='9')){
		H_dataH = data1-'0';
	}
	else if ((data1>='A')&&(data1<='F')){
		H_dataH = 0x0a+(data1-'A');
	}
	else if ((data1>='a')&&(data1<='f')){
		H_dataH = 0x0a+(data1-'a');
	}

	if ((data2>='0')&&(data2<='9')){
		H_dataL = data2-'0';
	}
	else if ((data2>='A')&&(data2<='F')){
		H_dataL = 0x0a+(data2-'A');
	}
	else if ((data2>='a')&&(data2<='f')){
		H_dataL = 0x0a+(data2-'a');
	}

	return(((H_dataH<<4) | H_dataL));
}



/******************************************************************************
 * 
 *    @name       Disk_App
 *    
 *    @brief      
 *                  
 *    @param      None
 * 
 *    @return     None
 *    
 *****************************************************************************/
int Intelhex_function(void)
{
	int_8 inputdata;
	int erct;
	int i;
	uint_32 sum;
	uint_8 sum_code;

	while(1){
		erct = FILE_get_data(&inputdata);
		if (erct < 0){
			return E_OK;
		}

		if (hex_mode == INTELHEX_NONE){
			if (inputdata == ':'){
				hex_mode = INTELHEX_GET;
				hex_byte_count = 0;
				hex_data[hex_byte_count] = inputdata;
				hex_byte_count++;
			}
		}
		else if(hex_mode == INTELHEX_GET){
			if (inputdata == ':'){
				hex_mode = INTELHEX_GET;
				hex_byte_count = 0;
				hex_data[hex_byte_count] = inputdata;
				hex_byte_count++;
			}
			else if (inputdata == '\n'){
				sum = 0;

				hex_code[0] = Hex_to_char_function(hex_data[1], hex_data[2]);

				hex_code[1] = Hex_to_char_function(hex_data[3], hex_data[4]);
				hex_code[2] = Hex_to_char_function(hex_data[5], hex_data[6]);

				hex_code[3] = Hex_to_char_function(hex_data[7], hex_data[8]);

				sum = hex_code[0] + hex_code[1] + hex_code[2] + hex_code[3];

				for(i=0;i<hex_code[0];i++){
					hex_code[4+i] = Hex_to_char_function(hex_data[(i*2)+9], hex_data[(i*2)+10]);
					sum = sum + hex_code[4+i];
				}

				sum_code = hex_code[4+hex_code[0]] = Hex_to_char_function(hex_data[(hex_code[0]*2)+9], hex_data[(hex_code[0]*2)+10]);

				if (sum_code == (uint_8)(((~(sum&0xff))+1)&0xff)){
					printf("*");
				}
				else{
					printf("-");
				}
				hex_mode = INTELHEX_NONE;
				hex_data[hex_byte_count] = 0;
				hex_byte_count++;
				//printf("%s",&hex_data[0]);
				switch(hex_code[3]){
					case 0x00:
						lo_addr = ((hex_code[1]<<8)&0xff00l|(hex_code[2]&0x00ffl));
						pcm_data_mem.addr = (uint_32)(hi_addr+lo_addr);
						pcm_data_mem.data = (uint_8*)&hex_code[4];
						pcm_data_mem.size = hex_code[0];
						ioctl(pcm_dev_handle1, IO_IOCTL_QSPI_BLOCK_SET_MEM, (pointer)&pcm_data_mem);
						//printf(" %08x %02x\n", (hi_addr+lo_addr),((~(sum&0xff))+1)&0xff);
						break;

					case 0x01:
						break;
					case 0x02:
						break;
					case 0x03:
						break;

					case 0x04:
						hi_addr = (((hex_code[4]<<8)&0xff00l|(hex_code[5]&0x00ffl))<<16);
						break;
				}
			}
			else{
				hex_data[hex_byte_count] = inputdata;
				hex_byte_count++;
			}
		}
	}

    return E_OK;
}


/* EOF */