/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: khci.h$
* $Version : 3.4.5.0$
* $Date    : Oct-5-2009$
*
* Comments:
*
*   This file contains KHCI-specific implementations of USB interfaces
*
*END************************************************************************/

#ifndef __khci_h__
#define __khci_h__

#include "usbprv_host.h"

//basic scheduling packets algorithm, schedules next packet to the beginning of next frame
//#define KHCICFG_BASIC_SCHEDULING

//scheduling based on time and packet length, not just SOF synchronizing
#define KHCICFG_TIMEBASED_SCHEDULING
#define KHCICFG_THSLD 820

//scheduling based on time and packet length, with fast functions, applicable only if 1 ticks = N * 1msec
//the threshold can be higher compared to standard time based scheduling
//#define KHCICFG_TIMEBASED_SCHEDULING_FAST    
//#define KHCICFG_THSLD 930

//#define KHCICFG_THSLD_DELAY 60
#endif